diff --git a/src/backend/optimizer/util/restrictinfo.c b/src/backend/optimizer/util/restrictinfo.c
index 9e1458401c..ca3e764c20 100644
--- a/src/backend/optimizer/util/restrictinfo.c
+++ b/src/backend/optimizer/util/restrictinfo.c
@@ -96,7 +96,7 @@ make_restrictinfo(PlannerInfo *root,
  * make_plain_restrictinfo
  *
  * Common code for the main entry points and the recursive cases.  Also,
- * useful while contrucitng RestrictInfos above OR clause, which already has
+ * useful while constructing RestrictInfos above OR clause, which already has
  * RestrictInfos above its subclauses.
  */
 RestrictInfo *